"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.dumpEvent = void 0;
const chalk = require("chalk");
const node_opcua_data_model_1 = require("node-opcua-data-model");
const node_opcua_status_code_1 = require("node-opcua-status-code");
const node_opcua_variant_1 = require("node-opcua-variant");
/**
 *
 * @param session
 * @param fields
 * @param eventFields
 */
function dumpEvent(session, fields, eventFields) {
    return __awaiter(this, void 0, void 0, function* () {
        function getBrowseName(_session, nodeId) {
            return __awaiter(this, void 0, void 0, function* () {
                const dataValue = yield _session.read({
                    attributeId: node_opcua_data_model_1.AttributeIds.BrowseName,
                    nodeId
                });
                if (dataValue.statusCode === node_opcua_status_code_1.StatusCodes.Good) {
                    const browseName = dataValue.value.value.name;
                    return browseName;
                }
                else {
                    return "???";
                }
            });
        }
        function w(str, l) {
            return (str + "                                      ").substr(0, l);
        }
        function __dumpEvent1(_session, _fields, variant, index) {
            return __awaiter(this, void 0, void 0, function* () {
                if (variant.dataType === node_opcua_variant_1.DataType.Null) {
                    return;
                }
                if (variant.dataType === node_opcua_variant_1.DataType.NodeId) {
                    const name = yield getBrowseName(_session, variant.value);
                    // tslint:disable-next-line: no-console
                    console.log(chalk.yellow(w(name, 30), w(_fields[index], 25)), chalk.cyan(w(node_opcua_variant_1.DataType[variant.dataType], 10).toString()), chalk.cyan.bold(name), "(", w(variant.value, 20), ")");
                }
                else {
                    // tslint:disable-next-line: no-console
                    console.log(chalk.yellow(w("", 30), w(_fields[index], 25)), chalk.cyan(w(node_opcua_variant_1.DataType[variant.dataType], 10).toString()), variant.value);
                }
            });
        }
        function __dumpEvent(_session, _fields, _eventFields) {
            return __awaiter(this, void 0, void 0, function* () {
                let index = 0;
                const promises = [];
                for (const variant of _eventFields) {
                    promises.push(__dumpEvent1(_session, _fields, variant, index));
                    index++;
                }
                yield Promise.all(promises);
            });
        }
        yield __dumpEvent(session, fields, eventFields);
    });
}
exports.dumpEvent = dumpEvent;
//# sourceMappingURL=client_alarm_tools_dump_event.js.map