"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.publicKeyAndPrivateKeyMatches = void 0;
const _1 = require(".");
const explore_private_key_1 = require("./explore_private_key");
function publicKeyAndPrivateKeyMatches(certificate, privateKey) {
    const i = _1.exploreCertificate(certificate);
    const j = explore_private_key_1.explorePrivateKey(privateKey);
    const modulus1 = i.tbsCertificate.subjectPublicKeyInfo.subjectPublicKey.modulus;
    const modulus2 = j.modulus;
    if (modulus1.length != modulus2.length) {
        return false;
    }
    return modulus1.toString("hex") === modulus2.toString("hex");
}
exports.publicKeyAndPrivateKeyMatches = publicKeyAndPrivateKeyMatches;
//# sourceMappingURL=public_private_match.js.map