/**
 * @module node-opcua-data-model
 */
import { BinaryStream, OutputBinaryStream } from "node-opcua-binary-stream";
export declare enum AccessLevelFlag {
    CurrentRead = 1,
    CurrentWrite = 2,
    HistoryRead = 4,
    HistoryWrite = 8,
    SemanticChange = 16,
    StatusWrite = 32,
    TimestampWrite = 64,
    NONE = 2048,
    None = 2048
}
export declare type AccessLevelFlagString = "CurrentRead" | "CurrentWrite" | "HistoryRead" | "HistoryWrite" | "StatusWrite" | "TimestampWrite";
export declare function convertAccessLevelFlagToByte(accessLevel: AccessLevelFlag): number;
export declare function makeAccessLevelFlag(str: string | number | null): AccessLevelFlag;
export declare const coerceAccessLevelFlag: typeof makeAccessLevelFlag;
export declare function randomAccessLevel(): AccessLevelFlag;
export declare function _accessLevelFlagToString(accessLevelFlag: number): string[];
export declare function accessLevelFlagToString(accessLevelFlag: AccessLevelFlag): string;
export declare function decodeAccessLevelFlag(stream: BinaryStream): AccessLevelFlag;
export declare function encodeAccessLevelFlag(value: AccessLevelFlag, stream: OutputBinaryStream): void;
