"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getBasicDataType = void 0;
const node_opcua_data_model_1 = require("node-opcua-data-model");
const node_opcua_status_code_1 = require("node-opcua-status-code");
const find_basic_datatype_1 = require("./find_basic_datatype");
function getBasicDataType(session, variableNodeId, callback) {
    let dataTypeId = null;
    const nodeToRead = {
        attributeId: node_opcua_data_model_1.AttributeIds.DataType,
        variableNodeId
    };
    session.read(nodeToRead, 0, (err, dataValue) => {
        if (err) {
            return callback(err);
        }
        /* istanbul ignore next */
        if (!dataValue) {
            return callback(new Error("Internal Error"));
        }
        /* istanbul ignore next */
        if (dataValue.statusCode.isNot(node_opcua_status_code_1.StatusCodes.Good)) {
            return callback(new Error("cannot read DataType Attribute " + dataValue.statusCode.toString()));
        }
        dataTypeId = dataValue.value.value;
        find_basic_datatype_1.findBasicDataType(session, dataTypeId, callback);
    });
}
exports.getBasicDataType = getBasicDataType;
//# sourceMappingURL=get_basic_datatype.js.map